package edu.sc.seis.cormorant.event;

import edu.sc.seis.fissuresUtil.cache.CacheEvent;
import edu.sc.seis.fissuresUtil.database.NotFound;
import edu.sc.seis.fissuresUtil.flow.querier.EventFinderQuery;


public interface EventDataAccess {
    
    /** gets a CacheEvent for the given database id */
    public CacheEvent getEvent(int dbid) throws NotFound;
    
    public CacheEvent[] getByName(String name);
    
    /** returns the database ids of all events that match the query */
    public int[] query(EventFinderQuery q);

    public String[] getCatalogs();
    
    public String[] getContributors() ;
    
    public String[] getCatalogsFor(String contributor);
}
